// ========================= XMEGA64_A1 ZigBee SLAVE2 α׷ ===============
//  CPU : ATmegaxxxA1
//     ¥ : 2010-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : AVRstudio4.18 
//      : Master/SLAVE1/SLAVE2  
//            COM7-RS232(PC)    : 19200,N,8,1
//            COM8-RS485(XBee)  : 9600,N,8,1
// PortF.4(OUT) : RST\(L:,H:Reset)
// PortF.5(OUT) : XBee Sleep(0:NON,1:SLEEP) ::    .
//            ٸ A1 ø CPU  Ʒ ׸񿡼  :
//            Project->Configuration Options->Device(atxmega64a1,atmega128a1,..)->Ȯ
// ----------------------------------------------------------------------------
// ũ 
#define	__STDIO_FDEVOPEN_COMPAT_12

#define	STX	0x02						// COM  ڵ
#define	ETX	0x03						// COM    ڵ
#define	SLAVE_NUM	'2'					// SLAVE ȣ('1' -  '2')

// ⺻ 
// === AVR includes ===
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdbool.h>
//#include <float.h>
//#include <math.h>

#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <util/delay.h>

//  ۼ ̺귯 
#include "port_drv.h"						// CPU Ʈ 
#include "usart_drv.h"						//  
#include "adc_drv.h"						// ADC 
#include "dac_drv.h"						// DAC 
#include "ebi_drv.h"						// EX BUS(SRAM,SDRAM) 

//  
#include "cpusetup.inc"						// cpu  ͷƮ  ƾ

// Լ 
void Master_Send(char num);					// Master  
int LrcCul(char buf[],int max_cnt);				// SLAE FRAME  LRC

//  
int tx_cnt = 0;							//  ī

// ===============================  α׷ =============================
// [μ]: void
// ---------------------------------------------------------------------------
int main(void)
{
char buf[10];
int crc;

	cpu_setup();						// cpuʱȭ

	PORTF.OUT &= ~0x10;					// Zigbee Reset
	timer0_base_cnt = 0;					// ð 500ms
	while(timer0_base_cnt < 50);
	PORTF.OUT |= 0x10;					// Zigbee NON Reset
	timer0_base_cnt = 0;					// ð 1S
	while(timer0_base_cnt < 100);

	timer0_tx_cnt = 0;					// ۽ Ÿ̸ ʱȭ
	while(1){						// Place your code here
		if(com8_rx_eflg){				// SLAVE  ó
			if(com8_rx_data[1] == SLAVE_NUM){	// ڱ  ȣ ˻ 
				crc = LrcCul(com8_rx_data,com8_rx_udi-3) & 0xff;// üũ 
				sprintf(buf,"%02X",crc);
				if(buf[0] == com8_rx_data[com8_rx_udi-3] && buf[1] == com8_rx_data[com8_rx_udi-2]){// LRC OK?
					Master_Send(SLAVE_NUM);	// Master  
					tx_cnt++;		//  ī 
					if(tx_cnt >= 9999) tx_cnt = 0;// 0 -> 9999 -> 0
				}
			}
			com8_rx_eflg = 0;
		}
	}
	return 0;
}

// ========================== Master   ===========================
// [μ]: char num
// Item1 :  SLAVE ȣ('1'-'2')
// ---------------------------------------------------------------------------
void Master_Send(char num)
{
char buf[10];
char com_tx_buf[50];
int i = 0,j,crc = 0;

	com_tx_buf[i++] = STX;					// STX 
	com_tx_buf[i++] = num;					// NUM 
	com_tx_buf[i++] = 'R';					// COMMAND 
	
	sprintf(buf,"%04d",tx_cnt);				// ī  4byte int
	com_tx_buf[i++] = buf[0];
	com_tx_buf[i++] = buf[1];
	com_tx_buf[i++] = buf[2];
	com_tx_buf[i++] = buf[3];
	
	for(j = 0; j < i; j++) crc ^= com_tx_buf[j];		// LRC 
	sprintf(buf,"%02X",crc&0xff);
	com_tx_buf[i++] = buf[0];				// LRC High
	com_tx_buf[i++] = buf[1];    				// LRC Low
	com_tx_buf[i++] = ETX;       				// ETX 
	com_tx_buf[i] = 0;       				// NULL 

	for(j = 0; j < i; j++) putchar_8(com_tx_buf[j]);	//  ۽(COM8)

	printf("send : %s\r\n",com_tx_buf);			// PC ۽  (ÿ)
}

// =========================== LRC  ==========================
// [μ] char buf[],int max_cnt
// Item1:  ڷ 
// Item2: ڷ 
// [] 
// ----------------------------------------------------------------
int LrcCul(char buf[],int max_cnt)
{
int i,accum = 0;

	for(i = 0; i < max_cnt;i++) accum ^= buf[i];		// XOR 
	return(accum & 0xff);
}
