// ================================ DAC  ==============================
// ] atxmegaxxxA1 ø DAC 
//       * atmel DAC_driver ҽ
// ----------------------------------------------------------------------------
#ifndef __DAC_DRV_INCLUDED__
#define __DAC_DRV_INCLUDED__

// ũ 
typedef enum DAC_CH_enum {
	CH0 = 0x00,
	CH1 = 0x01
} DAC_CH_t;

/*! \brief Enumerator for DAC event trigger. */
typedef enum DAC_TRIG_enum {
	DAC_TRIG_0_0 = 0x00,					/*!< Trigger on no channel. */
	DAC_TRIG_0_1 = DAC_CH0TRIG_bm,				/*!< Trigger on channel 0. */
	DAC_TRIG_1_0 = DAC_CH1TRIG_bm,				/*!< Trigger on channel 1. */
	DAC_TRIG_1_1 = ( DAC_CH1TRIG_bm | DAC_CH0TRIG_bm )	/*!< Trigger on both channels. */
} DAC_TRIG_t;

/* Definition of macros. */

/*! \brief This macro disables the selected DAC module.
 *
 *  \param  _dac  The DAC module, either DACA or DACB.
 */
#define DAC_Disable( _dac )                ( (_dac)->CTRLA &= ~DAC_ENABLE_bm )


/*! \brief Enable output to internal ADC.
 *
 *  This macro enables routing of the internal DAC output to
 *  the ADC module. This feature is useful for diagnostics and
 *  calibration purposes.
 *
 *  \param  _dac  The DAC module, either DACA or DACB.
 */
#define DAC_InternalOutput_Enable( _dac )  ( (_dac)->CTRLA |= DAC_IDOEN_bm )


/*! \brief This macro disables internal routing of the DAC output to an
 *         internal ADC module.
 *
 *  \param  _dac  The DAC module, either DACA or DACB.
 */
#define DAC_InternalOutput_Disable( _dac ) ( (_dac)->CTRLA &= ~DAC_IDOEN_bm )

// Լ 
void DAC_SingleChannel_Enable(DAC_t *dac,DAC_REFSEL_t convRef, bool leftAdjust);
void DAC_DualChannel_Enable(DAC_t *dac, DAC_REFSEL_t convRef,bool leftAdjust,DAC_CONINTVAL_t sampleInterval,DAC_REFRESH_t refreshInterval);
void DAC_Channel_Write(DAC_t *dac,unsigned int data,DAC_CH_t channel);
bool DAC_Channel_DataEmpty(DAC_t *dac,DAC_CH_t channel);
void DAC_EventAction_Set(DAC_t *dac,DAC_TRIG_t trigChannel,unsigned char eventLine);

#endif
