// ======================= AtxmegaxxxA1 EX_BUS  α׷ ==================
//  CPU : ATmegaxxxA1
//     ¥ : 2010-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR 2.04.6
// ----------------------------------------------------------------------------
// ⺻ 
#include <io.h>							// CPU  

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdbool.h>

//  
#include "ebi_drv.h"						// EBI 

// =============================== EBI Enable =================================
// [μ] EBI_SDDATAW_t sdramDataWidth, EBI_LPCMODE_t lpcMode, EBI_SRMODE_t sramMode, EBI_IFMODE_t interfaceMode
// Item1: EBI SDRAM Data Width Setting(EBI_SDDATAW_4BIT_gc,EBI_SDDATAW_8BIT_gc)
// Item2: EBI SRAM Low Pin-count Mode(EBI_LPCMODE_ALE1_gc,EBI_LPCMODE_ALE12_gc)
// Item3: SRAM Mode(EBI_SRMODE_ALE1_gc,EBI_SRMODE_ALE2_gc,EBI_SRMODE_ALE12_gc,EBI_SRMODE_NOALE_gc)
// Item4: EBI Interface Mode(EBI_IFMODE_DISABLED_gc,EBI_IFMODE_3PORT_gc,EBI_IFMODE_4PORT_gc,EBI_IFMODE_2PORT_gc)
// ----------------------------------------------------------------------------
void EBI_Enable(EBI_SDDATAW_t sdramDataWidth, EBI_LPCMODE_t lpcMode, EBI_SRMODE_t sramMode, EBI_IFMODE_t interfaceMode)
{
	EBI.CTRL = (unsigned char)sdramDataWidth | lpcMode | sramMode | interfaceMode;
}

// =============================== EBI EnableSRAM =============================
// [μ] EBI_CS_t *chipSelect,EBI_CS_ASPACE_t addrSpace,void *baseAddr, unsigned char waitStateCycles
// Item1: Chip Select(EBI.CS0,EBI.CS1,EBI.CS2,EBI.CS3)
// Item2: Chip Select Address
//        (EBI_CS_ASPACE_256B_gc, EBI_CS_ASPACE_512B_gc, EBI_CS_ASPACE_1KB_gc,
//         EBI_CS_ASPACE_2KB_gc,  EBI_CS_ASPACE_4KB_gc,  EBI_CS_ASPACE_8KB_gc,
//         EBI_CS_ASPACE_16KB_gc, EBI_CS_ASPACE_32KB_gc, EBI_CS_ASPACE_64KB_gc,
//         EBI_CS_ASPACE_128KB_gc,EBI_CS_ASPACE_256KB_gc,EBI_CS_ASPACE_512KB_gc,
//         EBI_CS_ASPACE_1MB_gc,  EBI_CS_ASPACE_2MB_gc,  EBI_CS_ASPACE_4MB_gc,
//         EBI_CS_ASPACE_8MB_gc,  EBI_CS_ASPACE_16M_gc
// Item3: Base Address
// Item4: Wait State(EBI_CS_SRWS_0CLK_gc, EBI_CS_SRWS_1CLK_gc, EBI_CS_SRWS_2CLK_gc, EBI_CS_SRWS_3CLK_gc,
//                   EBI_CS_SRWS_4CLK_gc, EBI_CS_SRWS_5CLK_gc, EBI_CS_SRWS_6CLK_gc, EBI_CS_SRWS_7CLK_gc
// ----------------------------------------------------------------------------
void EBI_EnableSRAM(EBI_CS_t *chipSelect,EBI_CS_ASPACE_t addrSpace,unsigned int baseAddr, unsigned char waitStateCycles)
{
	(chipSelect)->CTRLB = ((chipSelect)->CTRLB & ~EBI_CS_SRWS_gm) | (waitStateCycles & EBI_CS_SRWS_gm);// Configure SRAM settings.
	(chipSelect)->BASEADDR = (((unsigned int) baseAddr)>>8) & (0xFFFFL<<(addrSpace>>2));// Truncate the base address to an address space boundary.
	// Last part of configuration and then enable Chip Select module in SRAM mode.
	(chipSelect)->CTRLA = ((chipSelect)->CTRLA & ~(EBI_CS_ASPACE_gm | EBI_CS_MODE_gm)) | addrSpace | EBI_CS_MODE_SRAM_gc;
}

// ================================= EBI_EnableLPC ===========================
// [μ] volatile EBI_CS_t *chipSelect, EBI_CS_ASPACE_t addrSpace, unsigned int baseAddr, unsigned char waitStateCycles
// Item1: Wait State(EBI_CS_SRWS_0CLK_gc, EBI_CS_SRWS_1CLK_gc, EBI_CS_SRWS_2CLK_gc, EBI_CS_SRWS_3CLK_gc,
//                   EBI_CS_SRWS_4CLK_gc, EBI_CS_SRWS_5CLK_gc, EBI_CS_SRWS_6CLK_gc, EBI_CS_SRWS_7CLK_gc
// Item2: Base Address
// Item3: EBI SRAM Low Pin-count Mode(EBI_LPCMODE_ALE1_gc,EBI_LPCMODE_ALE12_gc)
// ----------------------------------------------------------------------------
void EBI_EnableLPC(volatile EBI_CS_t *chipSelect, EBI_CS_ASPACE_t addrSpace, unsigned int baseAddr, unsigned char waitStateCycles)
{
	
	(chipSelect)->CTRLB = ((chipSelect)->CTRLB & ~EBI_CS_SRWS_gm) | (waitStateCycles & EBI_CS_SRWS_gm);// Configure SRAM LPC settings.
	(chipSelect)->BASEADDR = (((unsigned long) baseAddr)>>8) & (0xFFFFL<<(addrSpace>>2));// Truncate the base address to an address space boundary.
	// Last part of configuration and then enable Chip Select module in SRAM LPC mode.
	(chipSelect)->CTRLA = ((chipSelect)->CTRLA & ~(EBI_CS_ASPACE_gm | EBI_CS_MODE_gm)) | addrSpace | EBI_CS_MODE_LPC_gc;
}

// ================================= EBI EnableSDRAM ==========================
// [μ] EBI_CS_ASPACE_t addrSpace, unsigned int baseAddr, bool casLatency, bool rowBits, EBI_SDCOL_t columnBits,
//        EBI_MRDLY_t modeRegisterDelay, EBI_ROWCYCDLY_t rowCycleDelay, EBI_RPDLY_t rowToPrechargeDelay, EBI_WRDLY_t writeRecoveryDelay,
//        EBI_ESRDLY_t exitSelfRefreshToActiveDelay, EBI_ROWCOLDLY_t rowToColumnDelay, unsigned int refreshPeriod, unsigned int initializationDelay
// Item1: Chip Select Address
//        (EBI_CS_ASPACE_256B_gc, EBI_CS_ASPACE_512B_gc, EBI_CS_ASPACE_1KB_gc,
//         EBI_CS_ASPACE_2KB_gc,  EBI_CS_ASPACE_4KB_gc,  EBI_CS_ASPACE_8KB_gc,
//         EBI_CS_ASPACE_16KB_gc, EBI_CS_ASPACE_32KB_gc, EBI_CS_ASPACE_64KB_gc,
//         EBI_CS_ASPACE_128KB_gc,EBI_CS_ASPACE_256KB_gc,EBI_CS_ASPACE_512KB_gc,
//         EBI_CS_ASPACE_1MB_gc,  EBI_CS_ASPACE_2MB_gc,  EBI_CS_ASPACE_4MB_gc,
//         EBI_CS_ASPACE_8MB_gc,  EBI_CS_ASPACE_16M_gc
// Item2: Base Address
// Item3: SDRAM CAS Latency Setting
// Item4:  SDRAM ROW Bits Setting
// Item5:  SDRAM Column Setting( EBI_SDCOL_8BIT_gc,  EBI_SDCOL_9BIT_gc,
//                               EBI_SDCOL_10BIT_gc, EBI_SDCOL_11BIT_gc)
// Item6: Mode Register Delay(EBI_MRDLY_0CLK_gc, EBI_MRDLY_1CLK_gc)
//                            EBI_MRDLY_2CLK_gc, EBI_MRDLY_3CLK_gc)
// Item7: Row Cycle Delay(EBI_ROWCYCDLY_0CLK_gc, EBI_ROWCYCDLY_1CLK_gc, EBI_ROWCYCDLY_2CLK_gc
//                        EBI_ROWCYCDLY_3CLK_gc, EBI_ROWCYCDLY_4CLK_gc, EBI_ROWCYCDLY_5CLK_gc
//                        EBI_ROWCYCDLY_6CLK_gc, EBI_ROWCYCDLY_7CLK_gc)
// Item8: Row to Pre-charge Delay(EBI_RPDLY_0CLK_gc, EBI_RPDLY_1CLK_gc, EBI_RPDLY_2CLK_gc,
//                                EBI_RPDLY_3CLK_gc, EBI_RPDLY_4CLK_gc, EBI_RPDLY_5CLK_gc.
//                                EBI_RPDLY_6CLK_gc, EBI_RPDLY_7CLK_gc)
// Item9:  Write Recovery Delay(EBI_WRDLY_0CLK_gc, EBI_WRDLY_1CLK_gc, EBI_WRDLY_2CLK_gc, EBI_WRDLY_3CLK_gc)
// Item10: Exit Self Refresh to Active Delay(EBI_ESRDLY_0CLK_gc, EBI_ESRDLY_1CLK_gc, EBI_ESRDLY_2CLK_gc, EBI_ESRDLY_3CLK_gc,
//                             EBI_ESRDLY_4CLK_gc, EBI_ESRDLY_5CLK_gc, EBI_ESRDLY_6CLK_gc, EBI_ESRDLY_7CLK_gc)
// Item11: Row to Column Delay(EBI_ROWCOLDLY_0CLK_gc, EBI_ROWCOLDLY_1CLK_gc, EBI_ROWCOLDLY_2CLK_gc, EBI_ROWCOLDLY_3CLK_gc,
//                             EBI_ROWCOLDLY_4CLK_gc, EBI_ROWCOLDLY_5CLK_gc, EBI_ROWCOLDLY_6CLK_gc, EBI_ROWCOLDLY_7CLK_gc)
// Item12: Refresh Period
// Item13: Initialization Delay
// ----------------------------------------------------------------------------
void EBI_EnableSDRAM( EBI_CS_ASPACE_t addrSpace, unsigned int baseAddr, bool casLatency, bool rowBits, EBI_SDCOL_t columnBits,
                      EBI_MRDLY_t modeRegisterDelay, EBI_ROWCYCDLY_t rowCycleDelay, EBI_RPDLY_t rowToPrechargeDelay, EBI_WRDLY_t writeRecoveryDelay,
                      EBI_ESRDLY_t exitSelfRefreshToActiveDelay, EBI_ROWCOLDLY_t rowToColumnDelay, unsigned int refreshPeriod, unsigned int initializationDelay)
{
	// Set two single-bit fields and one larger field, while protecting reserved bits.
	EBI.SDRAMCTRLA = (EBI.SDRAMCTRLA & ~(EBI_SDCAS_bm | EBI_SDROW_bm | EBI_SDCOL_gm)) | (casLatency ? EBI_SDCAS_bm : 0) | (rowBits ? EBI_SDROW_bm : 0) | columnBits;

	// Set delay counts. Fields fill up the entire registers. 
	EBI.SDRAMCTRLB = (unsigned char) modeRegisterDelay | rowCycleDelay | rowToPrechargeDelay;
	EBI.SDRAMCTRLC = (unsigned char) writeRecoveryDelay | exitSelfRefreshToActiveDelay | rowToColumnDelay;

	// Set refresh period and initialization delay, truncate too large values.
	EBI.REFRESH = refreshPeriod & 0x03FF;
	EBI.INITDLY = initializationDelay & 0x3FFF;

	// Last part of configuration and then enable Chip Select module in SDRAM mode.
	EBI.CS3.CTRLB = (EBI.CS3.CTRLB & ~(EBI_CS_SDSREN_bm | EBI_CS_SDMODE_gm)) | EBI_CS_SDMODE_NORMAL_gc;

	EBI.CS3.BASEADDR = (((unsigned long)baseAddr)>>8) & (0xFFFFL<<(addrSpace>>2));// Truncate the base address to an address space boundary.
	EBI.CS3.CTRLA = (EBI.CS3.CTRLA & ~(EBI_CS_ASPACE_gm | EBI_CS_MODE_gm)) | addrSpace | EBI_CS_MODE_SDRAM_gc;
	while ((EBI.CS3.CTRLB & EBI_CS_SDINITDONE_bm) == 0);	// Wait for SDRAM to initialize
}
