// =========================== XMEGA64_A1 ZigBee Masterα׷ ==============
//  CPU : ATmega64A1
//     ¥ : 2010-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR 2.04.7
//      : Master/SLAVE1/SLAVE2  
//            COM7-RS232(PC)    : 19200,N,8,1
//            COM8-RS485(XBee)  : 9600,N,8,1
// PortF.4(OUT) : RST\(L:,H:Reset)
// PortF.5(OUT) : XBee Sleep(0:NON,1:SLEEP) ::    .
// ----------------------------------------------------------------------------
//  
#define	STX	0x02						// COM  ڵ
#define	ETX	0x03						// COM    ڵ

// ⺻ 
#include <io.h>							// CPU  

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <stdbool.h>
#include <delay.h>
//#include <float.h>
//#include <math.h>

//  ۼ ̺귯 
#include "port_drv.h"						// CPU Ʈ 
#include "usart_drv.h"						//  
#include "adc_drv.h"						// ADC 
#include "dac_drv.h"						// DAC 
#include "ebi_drv.h"						// EX BUS(SRAM,SDRAM) 

//  
#include "cpusetup.inc"						// cpu  ͷƮ  ƾ

// Լ 
void Slave_Request(char num);					// SLAVEn  䱸
int LrcCul(char buf[],int max_cnt);				// SLAE FRAME  LRC

//  

// ===============================  α׷ =============================
// [μ]: void
// ---------------------------------------------------------------------------
void main(void)
{
char buf[10];
char snum = '1';
int crc;

	cpu_setup();						// cpuʱȭ

	PORTF.OUT &= ~0x10;					// Zigbee Reset
	timer0_base_cnt = 0;					// ð 500ms
	while(timer0_base_cnt < 50);
	PORTF.OUT |= 0x10;					// Zigbee NON Reset
	timer0_base_cnt = 0;					// ð 1S
	while(timer0_base_cnt < 100);

	timer0_tx_cnt = 0;					// ۽ Ÿ̸ ʱȭ
	while(1){						// Place your code here
// XBee,XBee-PRO : 200ms̻
// XBee2 : ִ 3s
		if(timer0_tx_cnt >= 50){			//  500ms SLAVE  䱸(50*10ms)
			Slave_Request(snum);			//  䱸
			snum++;					// SZLAVE ȣ (1-2)
			if(snum >= '3') snum = '1';
			timer0_tx_cnt = 0;
		}
		if(com8_rx_eflg){				// SLAVE  ó
			crc = LrcCul(com8_rx_data,com8_rx_udi-3) & 0xff;// üũ 
			sprintf(buf,"%02X",crc);
			if(buf[0] == com8_rx_data[com8_rx_udi-3] && buf[1] == com8_rx_data[com8_rx_udi-2]){// LRC OK?
				printf("  :: RECV : %s",com8_rx_data);// PC   
			}
			com8_rx_eflg = 0;
		}
	}
}

// ========================== SLAVEn  䱸 ===========================
// [μ]: char num
// Item1 :  SLAVE ȣ('1'-'2')
// ---------------------------------------------------------------------------
void Slave_Request(char num)
{
char buf[10];
char com_tx_buf[50];
int i = 0,j,crc = 0;

	com_tx_buf[i++] = STX;					// STX 
	com_tx_buf[i++] = num;					// NUM 
	com_tx_buf[i++] = 'R';					// COMMAND 
	
	for(j = 0; j < i; j++) crc ^= com_tx_buf[j];		// LRC 
	sprintf(buf,"%02X",crc&0xff);
	com_tx_buf[i++] = buf[0];				// LRC High
	com_tx_buf[i++] = buf[1];    				// LRC Low
	com_tx_buf[i++] = ETX;       				// ETX 
	com_tx_buf[i] = 0;       				// NULL 

	for(j = 0; j < i; j++) putchar_8(com_tx_buf[j]);	//  ۽(COM8)
	printf("\r\nsend : %s",com_tx_buf);			// PC ۽  
}

// =========================== LRC  ==========================
// [μ] char buf[],int max_cnt
// Item1:  ڷ 
// Item2: ڷ 
// [] 
// ----------------------------------------------------------------
int LrcCul(char buf[],int max_cnt)
{
int i,accum = 0;

	for(i = 0; i < max_cnt;i++) accum ^= buf[i];		// XOR 
	return(accum & 0xff);
}
