// ======================== AtxmegaxxxA1 CPU PORT  α׷ ===============
//  CPU : ATmegaxxxA1
//     ¥ : 2010-
//      : Ver1.0
//    : www.cpuplaza.com
// Ϸ : CodeVisionAVR 2.04.6
// ----------------------------------------------------------------------------
// ⺻ 
#include <io.h>							// CPU  

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

//  
#include "port_drv.h"						// cpu port 

// Լ 

// ========================== Port Pin Configuration =========================
// [μ] PORT_t *port, unsigned char MpcMask, unsigned char SlewRate,
//        unsigned char Inverted, PORT_OPC_t OutputPull,PORT_ISC_t InputSense
// Item1: I/O PORT 
// Item2: Multi Pin Configuration Mask Register
// Item3: Slew Rate Limit Enable
// Item4: Inverted I/O Enable
// Item5: Output and Pull Configuration(TOTEM,BUSKEEPER,PULLDOWN,PULLUP,WIREDOR,WIREDAND,WIREDORPULL,WIREDANDPULL)
// Item6: Input/Sense Configuration(BOTHEDGES,RISING,FALLING,LEVEL,INPUT_DISABLE)
// ----------------------------------------------------------------------------
void PORT_ConfigurePins(PORT_t *port, unsigned char MpcMask, unsigned char SlewRate, unsigned char Inverted, PORT_OPC_t OutputPull,PORT_ISC_t InputSense)
{
unsigned char datac;

	datac = (unsigned char)(OutputPull | InputSense);	// PINnCTRL ISC[0..2], OPC[3..5]
	if(SlewRate) datac |= PORT_SRLEN_bm;			// SRLEN bit
	if(Inverted) datac |= PORT_INVEN_bm;			// INVEN bit

	PORTCFG.MPCMASK = MpcMask;				// Multi Pin Configuration Mask Register
	(port)->PIN0CTRL = datac;				// Pin Configuration Register
}

// ========================= PORT Interrupt0 Configure =========================
// [μ] PORT_t *port,PORT_INT0LVL_t intLevel,unsigned char pinMask
// Item1: I/O PORT 
// Item2: Interrupt Level(OFF,LO,MED,HI)
// Item3: Interrupt Mask Register
// ----------------------------------------------------------------------------
void PORT_ConfigureInterrupt0(PORT_t *port,PORT_INT0LVL_t IntLevel,unsigned char IntMask)
{
	(port)->INTCTRL = ((port)->INTCTRL & ~PORT_INT0LVL_gm ) | IntLevel;// Interrupt Control Register : INT0LVL[0..1]
	(port)->INT0MASK = IntMask;				// INT0MASK[0..7]
}

// ========================= PORT Interrupt1 Configure =========================
// [μ] PORT_t *port,PORT_INT0LVL_t intLevel,unsigned char pinMask
// Item1: I/O PORT 
// Item2: Interrupt Level(OFF,LO,MED,HI)
// Item3: Interrupt Mask Register
// ----------------------------------------------------------------------------
void PORT_ConfigureInterrupt1(PORT_t *port,PORT_INT1LVL_t IntLevel,unsigned char IntMask)
{
	(port)->INTCTRL = ((port)->INTCTRL & ~PORT_INT1LVL_gm ) | IntLevel;// Interrupt Control Register : INT0LVL[0..1]
	(port)->INT1MASK = IntMask;				// INT0MASK[0..7]
}

// ========================= Virtual Port0 map Control ========================
// [μ] PORTCFG_VP0MAP_t port
// Item1:  I/O PORT 
// ----------------------------------------------------------------------------
void PORT_MapVirtualPort0(PORTCFG_VP0MAP_t port)
{
	PORTCFG.VPCTRLA = (PORTCFG.VPCTRLA & ~PORTCFG_VP0MAP_gm ) | port;
}

// ========================= Virtual Port1 map Control ========================
// [μ] PORTCFG_VP0MAP_t port
// Item1:  I/O PORT 
// ----------------------------------------------------------------------------
void PORT_MapVirtualPort1(PORTCFG_VP0MAP_t port)
{
	PORTCFG.VPCTRLA = (PORTCFG.VPCTRLA & ~PORTCFG_VP1MAP_gm ) | port;
}

// ========================= Virtual Port2 map Control ========================
// [μ] PORTCFG_VP0MAP_t port
// Item1:  I/O PORT 
// ----------------------------------------------------------------------------
void PORT_MapVirtualPort2(PORTCFG_VP0MAP_t port)
{
	PORTCFG.VPCTRLB = (PORTCFG.VPCTRLB & ~PORTCFG_VP2MAP_gm ) | port;
}

// ========================= Virtual Port3 map Control ========================
// [μ] PORTCFG_VP0MAP_t port
// Item1:  I/O PORT 
// ----------------------------------------------------------------------------
void PORT_MapVirtualPort3(PORTCFG_VP0MAP_t port)
{
	PORTCFG.VPCTRLB = (PORTCFG.VPCTRLB & ~PORTCFG_VP3MAP_gm ) | port;
}
 