// ========================= AtxmegaxxxA1 USART  α׷ =================
//  CPU : ATmegaxxxA1
//     ¥ : 2010-
//      : Ver1.0
// Ϸ : CodeVisionAVR 2.04.6
// Ϸ : AVRstudio4.18 
// ----------------------------------------------------------------------------
// ⺻ 
#include <io.h>							// CPU  

#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

#define _ALTERNATE_PUTCHAR_					// putchar() üϱ  

//  
//#include "usart_drv.h"					// usart 

// ============================== USART Port Init ============================
// [μ] USART_t *usart, unsigned char c_mode, long baud, unsigned char data_size
//        unsigned char p_mode, unsigned char sb_mode
// Item1: USART Port (USARTC0,USARTC1,USARTD0,USARTD1,USARTE0,USARTE1,USARTF0,USARTF1)
// Item2: commucation mode(USART_CMODE_ASYNCHRONOUS_gc, USART_CMODE_SYNCHRONOUS_gc,
//                         USART_CMODE_IRDA_gc, USART_CMODE_MSPI_gc)
// Item3: baud rate(300,600,1200,2400,4800,9600,19200,38400,57600,115200)
// Item4: data size(USART_CHSIZE_5BIT_gc,USART_CHSIZE_6BIT_gc,USART_CHSIZE_7BIT_gc,
//                  USART_CHSIZE_8BIT_gc,USART_CHSIZE_9BIT_gc)
// Item5: parity mode(USART_PMODE_DISABLED_gc, USART_PMODE_EVEN_gc, USART_PMODE_ODD_gc)
// Item6: stop mode(1STOP(1), 2STOPO(2))
// ----------------------------------------------------------------------------
void Com_Init(USART_t *usart, unsigned char c_mode, long baud, unsigned char data_size, unsigned char p_mode, unsigned char sb_mode)
{
unsigned char stop_c = 0;
	
	if(usart == &USARTC0){
		PORTC.DIR &= ~PIN2_bm;				// PORTC_2 Input
		PORTC.DIR |= PIN3_bm;				// PORTC_3 Output
		PORTC.OUT |= PIN3_bm;				// PORTC_3 = 1
	}
	if(usart == &USARTD0){
		PORTD.DIR &= ~PIN2_bm;				// PORTD_2 Input
		PORTD.DIR |= PIN3_bm;				// PORTD_3 Output
		PORTD.OUT |= PIN3_bm;				// PORTD_3 = 1
	}
	if(usart == &USARTE0){
		PORTE.DIR &= ~PIN2_bm;				// PORTF_2 Input
		PORTE.DIR |= PIN3_bm;				// PORTE_3 Output
		PORTE.OUT |= PIN3_bm;				// PORTE_3 = 1
	}
	if(usart == &USARTF0){
		PORTF.DIR &= ~PIN2_bm;				// PORTF_2 Input
		PORTF.DIR |= PIN3_bm;				// PORTF_3 Output
		PORTF.OUT |= PIN3_bm;				// PORTF_3 = 1
	}
	if(usart == &USARTC1){
		PORTC.DIR &= ~PIN6_bm;				// PORTC_6 Input
		PORTC.DIR |= PIN7_bm;				// PORTC_7 Output
		PORTC.OUT |= PIN7_bm;				// PORTC_7 = 1
	}
	if(usart == &USARTD1){
		PORTD.DIR &= ~PIN6_bm;				// PORTD_6 Input
		PORTD.DIR |= PIN7_bm;				// PORTD_7 Output
		PORTD.OUT |= PIN7_bm;				// PORTD_7 = 1
	}
	if(usart == &USARTE1){
		PORTE.DIR &= ~PIN6_bm;				// PORTF_6 Input
		PORTE.DIR |= PIN7_bm;				// PORTE_7 Output
		PORTE.OUT |= PIN7_bm;				// PORTE_7 = 1
	}
	if(usart == &USARTF1){
		PORTF.DIR &= ~PIN6_bm;				// PORTF_6 Input
		PORTF.DIR |= PIN7_bm;				// PORTF_7 Output
		PORTF.OUT |= PIN7_bm;				// PORTF_7 = 1
	}
	if(sb_mode == 2) stop_c = 0x08;				// 2STOP
	(usart)->CTRLC = c_mode | p_mode | data_size | stop_c;	// data,parity,char size, 1stop

// Interrupt set CTRLA
// RX : USART_RXCINTLVL_OFF_gc, USART_RXCINTLVL_LO_gc, USART_RXCINTLVL_MED_gc, USART_RXCINTLVL_HI_gc
// TX : USART_TXCINTLVL_OFF_gc, USART_TXCINTLVL_LO_gc, USART_TXCINTLVL_MED_gc, USART_TXCINTLVL_HI_gc
// Data Register Empty : USART_DREINTLVL_OFF_gc, USART_DREINTLVL_LO_gc, USART_DREINTLVL_MED_gc, USART_DREINTLVL_HI_gc
	(usart)->CTRLA = USART_RXCINTLVL_LO_gc | USART_TXCINTLVL_OFF_gc | USART_DREINTLVL_OFF_gc;// RX Lo level Interrupt
// baud rate set
// fPer = 32MHz
	switch(baud){
		case 300L:	
			(usart)->BAUDCTRLA = 0x04;		// BSEL = 3332
			(usart)->BAUDCTRLB = (unsigned char)(0x10 | 0x0d);// BSCALE = 1
			break;
		case 600L:	
			(usart)->BAUDCTRLA = 0x04;		// BSEL = 3332
			(usart)->BAUDCTRLB = (unsigned char)(0x00 | 0x0d);// BSCALE = 0
			break;
		case 1200L:	
			(usart)->BAUDCTRLA = 0x04;		// BSEL = 3332
			(usart)->BAUDCTRLB = (unsigned char)(0xf0 | 0x0d);// BSCALE = -1
			break;
		case 2400L:	
			(usart)->BAUDCTRLA = 0x01;		// BSEL = 3329
			(usart)->BAUDCTRLB = (unsigned char)(0xe0 | 0x0d);// BSCALE = -2
			break;
		case 4800L:	
			(usart)->BAUDCTRLA = 0xfd;		// BSEL = 3325
			(usart)->BAUDCTRLB = (unsigned char)(0xd0 | 0x0c);// BSCALE = -3
			break;
		case 9600L:	
			(usart)->BAUDCTRLA = 0xf5;		// BSEL = 3317
			(usart)->BAUDCTRLB = (unsigned char)(0xc0 | 0x0c);// BSCALE = -4
			break;
		case 19200L:	
			(usart)->BAUDCTRLA = 0xe5;		// BSEL = 3301
			(usart)->BAUDCTRLB = (unsigned char)(0xB0 | 0x0C);// BSCALE = -5
			break;
		case 38400L:	
			(usart)->BAUDCTRLA = 0xc5;		// BSEL = 3269
			(usart)->BAUDCTRLB = (unsigned char)(0xa0 | 0x0C);// BSCALE = -6
			break;
		case 57600L:	
			(usart)->BAUDCTRLA = 0x6e;		// BSEL = 2158
			(usart)->BAUDCTRLB = (unsigned char)(0xa0 | 0x08);// BSCALE = -6
			break;
		case 115200L:	
			(usart)->BAUDCTRLA = 0x2e;		// BSEL = 2094
			(usart)->BAUDCTRLB = (unsigned char)(0x90 | 0x08);// BSCALE = -7
			break;
		default: break;
	}
	(usart)->CTRLB = USART_RXEN_bm | USART_TXEN_bm;		// Receiver, Transmitter Enable
}

// ============================== COM1 1Ʈ ۽ =========================
// [μ] char data
// item1:  
// [] USARTC0
// --------------------------------------------------------------------------
int putchar_1(char data)
{
	while((USARTC0.STATUS & USART_DREIF_bm) == 0);		// UARTC0 ۽ 
	USARTC0.DATA = data;
	return(0);
}

// ============================== COM1 1Ʈ  =========================
// [μ] void
// []  
// [] USARTC0
// --------------------------------------------------------------------------
int getchar_1(void)
{
	while ((USARTC0.STATUS & USART_RXCIF_bm) == 0);		// UARTFC0  
	return(USARTC0.DATA);
}

// ============================== COM2 1Ʈ ۽ =========================
// [μ] char data                                                    
// item1:                                                  
// [] USARTC1
// --------------------------------------------------------------------------
int putchar_2(char data)                                               
{                                                                      
	while((USARTC1.STATUS & USART_DREIF_bm) == 0);		// UARTC1 ۽ 
	USARTC1.DATA = data;                                           
	return(0);                                                     
}                                                                      

// ============================== COM2 1Ʈ  =========================
// [μ] void                                                         
// []                                                    
// [] USARTC1
// --------------------------------------------------------------------------
int getchar_2(void)                                                    
{                                                                      
	while((USARTC1.STATUS & USART_RXCIF_bm) == 0);		// UARTC1  
	return(USARTC1.DATA);                                          
}                                                                      

// ============================== COM3 1Ʈ ۽ =========================
// [μ] char data                                                    
// item1:                                                  
// [] USARTD0
// --------------------------------------------------------------------------
int putchar_3(char data)                                               
{                                                                      
	while((USARTD0.STATUS & USART_DREIF_bm) == 0);		// UARTD0 ۽ 
	USARTD0.DATA = data;                                           
	return(0);                                                     
}                                                                      

// ============================== COM3 1Ʈ  =========================
// [μ] void                                                         
// []                                                    
// [] USARTD0
// --------------------------------------------------------------------------
int getchar_3(void)                                                    
{                                                                      
	while((USARTD0.STATUS & USART_RXCIF_bm) == 0);		// UARTD0  
	return(USARTD0.DATA);                                          
}                                                                      

// ============================== COM4 1Ʈ ۽ =========================
// [μ] char data                                                    
// item1:                                                  
// [] USARTD1
// --------------------------------------------------------------------------
int putchar_4(char data)                                               
{                                                                      
	while((USARTD1.STATUS & USART_DREIF_bm) == 0);		// UARTD1 ۽ 
	USARTD1.DATA = data;                                           
	return(0);                                                     
}                                                                      

// ============================== COM4 1Ʈ  =========================
// [μ] void                                                         
// []                                                    
// [] USARTD1
// --------------------------------------------------------------------------
int getchar_4(void)                                                    
{                                                                      
	while((USARTD1.STATUS & USART_RXCIF_bm) == 0);		// UARTD1  
	return(USARTD1.DATA);                                          
}                                                                      

// ============================== COM5 1Ʈ ۽ =========================
// [μ] char data                                                    
// item1:                                                  
// [] USARTE0
// --------------------------------------------------------------------------
int putchar_5(char data)                                               
{                                                                      
	while((USARTE0.STATUS & USART_DREIF_bm) == 0);		// UARTE0 ۽ 
	USARTE0.DATA = data;                                           
	return(0);                                                     
}                                                                      

// ============================== COM5 1Ʈ  =========================
// [μ] void                                                         
// []                                                    
// [] USARTE0
// --------------------------------------------------------------------------
int getchar_5(void)                                                    
{                                                                      
	while((USARTE0.STATUS & USART_RXCIF_bm) == 0);		// UARTE0  
	return(USARTE0.DATA);                                          
}                                                                      

// ============================== COM6 1Ʈ ۽ =========================
// [μ] char data                                                    
// item1:                                                  
// [] USARTE1
// --------------------------------------------------------------------------
int putchar_6(char data)                                               
{                                                                      
	while((USARTE1.STATUS & USART_DREIF_bm) == 0);		// UARTE1 ۽ 
	USARTE1.DATA = data;                                           
	return(0);                                                     
}                                                                      

// ============================== COM6 1Ʈ  =========================
// [μ] void                                                         
// []                                                    
// [] USARTE1
// --------------------------------------------------------------------------
int getchar_6(void)                                                    
{                                                                      
	while((USARTE1.STATUS & USART_RXCIF_bm) == 0);		// UARTE1  
	return(USARTE1.DATA);                                          
}                                                                      

// ============================== COM7 1Ʈ ۽ =========================
// [μ] char data                                                    
// item1:                                                  
// [] USARTF0
// --------------------------------------------------------------------------
int putchar_7(char data)                                               
{                                                                      
	while((USARTF0.STATUS & USART_DREIF_bm) == 0);		// UARTF0 ۽ 
	USARTF0.DATA = data;                                           
	return(0);                                                     
}                                                                      

// ============================== COM7 1Ʈ  =========================
// [μ] void                                                         
// []                                                    
// [] USARTF0
// --------------------------------------------------------------------------
int getchar_7(void)                                                    
{                                                                      
	while((USARTF0.STATUS & USART_RXCIF_bm) == 0);		// UARTF0  
	return(USARTF0.DATA);                                          
}                                                                      

// ============================== COM8 1Ʈ ۽ =========================
// [μ] char data                                                    
// item1:                                                  
// [] USARTF1
// --------------------------------------------------------------------------
int putchar_8(char data)                                               
{                                                                      
	while((USARTF1.STATUS & USART_DREIF_bm) == 0);		// UARTF1 ۽ 
	USARTF1.DATA = data;                                           
	return(0);                                                     
}                                                                      

// ============================== COM8 1Ʈ  =========================
// [μ] void                                                         
// []                                                    
// [] USARTF1
// --------------------------------------------------------------------------
int getchar_8(void)                                                    
{                                                                      
	while((USARTF1.STATUS & USART_RXCIF_bm) == 0);		// UARTF1  
	return(USARTF1.DATA);                                          
}                                                                      

// ============================== COM7 printf  ======================
// [μ] char c                                                    
// item1:                                                  
// [] USARTF0
// --------------------------------------------------------------------------
void putchar(char c)
{                                                                      
	while((USARTF0.STATUS & USART_DREIF_bm) == 0);		// UARTF0 ۽ 
	USARTF0.DATA = c;                                           
}                                                                      
